<?php

namespace App\Policies;

use App\Models\IndividualZone;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class IndividualZonePolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create individualzone', 'edit individualzone', 'view individualzone', 'delete individualzone'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, IndividualZone $individualZone): bool
    {
        return $user->hasPermissionTo('view individualzone');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create individualzone');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, IndividualZone $individualZone): bool
    {
        return $user->hasPermissionTo('edit individualzone');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, IndividualZone $individualZone): bool
    {
        return $user->hasPermissionTo('delete individualzone');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, IndividualZone $individualZone): bool
    {
        return $user->hasPermissionTo('restore individualzone');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, IndividualZone $individualZone): bool
    {
        return $user->hasPermissionTo('force delete individualzone');
    }
}
